Subject: Re: [PATCH] Marvell Libertas 8388 802.11b/g USB driver (v2)

From: Dan Williams <[email-masked]>
Date: Wed, 24 Jan 2007 13:52:35 -0500

On Wed, 2007-01-24 at 13:26 -0200, Marcelo Tosatti wrote:
> On Thu, Jan 18, 2007 at 03:22:50AM -0500, John W. Linville wrote:
> > On Wed, Jan 17, 2007 at 06:19:07PM -0500, Jeff Garzik wrote:
> > > Christoph Hellwig wrote:
> > > >On Wed, Jan 17, 2007 at 01:00:47PM -0500, Dan Williams wrote:
> > 
> > > >>allows the 8388 to continue routing other laptops' packets over the mesh
> > > >>*while the host CPU is asleep*.
> > > >
> > > >We're not going to put a lot of junk into the kernel just because the OLPC
> > > >folks decide to do odd powermanagment schemes.
> > > 
> > > We're not going to ignore useful power management schemes just because 
> > > they don't fit neatly into a pre-existing category.
> > > 
> > > I think the request to determine how all this maps into MLME is fair, 
> > > though.
> > 
> > Definitely.  Also, I wonder if there was any attempt to evaluate how
> > the ieee80211 (or d80211) code might be extended in order to elimnate
> > the need for some of the libertas wlan_* files?
> 
> The regulatory domain structures, channel information (struct
> ieee80211_channel), HW mode (struct ieee80211_hw_mode) compromised of
> supported channels and rates, and probably a few others in the same
> category. I can't see the possibility of using d80211 as it stands
> (designed for softmac cards dealing with 802.11 packets to/from the OS).
> 
> However, it does not make any sense to use the structures defined by
> d80211 if not effectively using it (we send/receive 802.3 frames to the
> firmware, after all), IMO.
> 
> As discussed on this thread, there is a lot of code to be cleanup up,
> but no structural changes AFAICT. Is there a general agreement on that,
> now?

I pushed for a general "lib80211" sort of thing at the Summit, which I
think was agreed in principle with others like Intel.  We need something
to hold the bits that are common to d80211 and non-softmac drivers.
These include scan result handling, some bits of the regulatory stuff
(at least structures and definitions for allowed channels and txpower in
each domain), and 802.3 <-> 802.11 framing conversion code.  We should
be able to fold more stuff in there as we go along.  But there certainly
will be code that both softmac/d80211 and non-softmac drivers (airo,
ipw2x00, libertas, etc) can share.

Dan